from src.interfaces import IRomanNumber

class RomanNumber(IRomanNumber):
    def convert(self, n: int) -> str:
        if not isinstance(n, int):
            raise ValueError("Eingabe muss eine ganze Zahl sein")
        if n <= 0 or n >= 4000:
            raise ValueError("Zahl muss zwischen 1 und 3999 liegen")

        val = [
            (1000, "M"), (900, "CM"), (500, "D"), (400, "CD"),
            (100, "C"), (90, "XC"), (50, "L"), (40, "XL"),
            (10, "X"), (9, "IX"), (5, "V"), (4, "IV"),
            (1, "I")
        ]

        result = ""
        for (value, numeral) in val:
            while n >= value:
                result += numeral
                n -= value
        return result